Index: squid/src/store_swapin.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapin.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/store_swapin.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/store_swapin.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapin.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: store_swapin.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapin Functions
  * AUTHOR: Duane Wessels
@@ -35,110 +35,50 @@
 
 #include "squid.h"
 
-typedef struct swapin_ctrl_t {
-    StoreEntry *e;
-    char *path;
-    SIH *callback;
-    void *callback_data;
-    store_client *sc;
-} swapin_ctrl_t;
+static STIOCB storeSwapInFileClosed;
 
-/* start swapping in */
-/* callback_data will become the tag on which the stat/open can be aborted */
 void
-storeSwapInStart(StoreEntry * e, SIH * callback, void *callback_data)
+storeSwapInStart(store_client * sc)
 {
-    swapin_ctrl_t *ctrlp;
+    StoreEntry *e = sc->entry;
     assert(e->mem_status == NOT_IN_MEMORY);
     if (!EBIT_TEST(e->flags, ENTRY_VALIDATED)) {
 	/* We're still reloading and haven't validated this entry yet */
-	callback(-1, callback_data);
 	return;
     }
     debug(20, 3) ("storeSwapInStart: called for %08X %s \n",
 	e->swap_file_number, storeKeyText(e->key));
-    assert(e->swap_status == SWAPOUT_WRITING || e->swap_status == SWAPOUT_DONE);
-    assert(e->swap_file_number >= 0);
-    assert(e->mem_obj != NULL);
-    ctrlp = xmalloc(sizeof(swapin_ctrl_t));
-    ctrlp->e = e;
-    ctrlp->callback = callback;
-    ctrlp->callback_data = callback_data;
-    if (EBIT_TEST(e->flags, ENTRY_VALIDATED))
-	storeSwapInValidateComplete(ctrlp, 0, 0);
-    else
-	storeValidate(e, storeSwapInValidateComplete, ctrlp, callback_data);
-}
-
-void
-storeSwapInValidateComplete(void *data, int retcode, int errcode)
-{
-    swapin_ctrl_t *ctrlp = (swapin_ctrl_t *) data;
-    StoreEntry *e;
-    if (retcode == -2 && errcode == -2) {
-	xfree(ctrlp);
+    if (e->swap_status != SWAPOUT_WRITING && e->swap_status != SWAPOUT_DONE) {
+	debug(20, 1) ("storeSwapInStart: bad swap_status (%s)\n",
+	    swapStatusStr[e->swap_status]);
 	return;
     }
-    e = ctrlp->e;
-    assert(e->mem_status == NOT_IN_MEMORY);
-    if (!EBIT_TEST(e->flags, ENTRY_VALIDATED)) {
-	/* Invoke a store abort that should free the memory object */
-	(ctrlp->callback) (-1, ctrlp->callback_data);
-	xfree(ctrlp);
+    if (e->swap_file_number < 0) {
+	debug(20, 1) ("storeSwapInStart: swap_file_number < 0\n");
 	return;
     }
-    ctrlp->path = xstrdup(storeSwapFullPath(e->swap_file_number, NULL));
-    debug(20, 3) ("storeSwapInValidateComplete: Opening %s\n", ctrlp->path);
-    store_open_disk_fd++;
-    file_open(ctrlp->path,
+    assert(e->mem_obj != NULL);
+    debug(20, 3) ("storeSwapInStart: Opening fileno %08X\n",
+	e->swap_file_number);
+    sc->swapin_sio = storeOpen(e->swap_file_number,
 	O_RDONLY,
-	storeSwapInFileOpened,
-	ctrlp,
-	ctrlp->callback_data);
+	storeSwapInFileClosed,
+	sc);
+    cbdataLock(sc->swapin_sio);
 }
 
-void
-storeSwapInFileOpened(void *data, int fd, int errcode)
+static void
+storeSwapInFileClosed(void *data, int errflag, storeIOState * sio)
 {
-    swapin_ctrl_t *ctrlp = data;
-    StoreEntry *e = ctrlp->e;
-    MemObject *mem = e->mem_obj;
-    struct stat sb;
-    if (fd == -2 && errcode == -2) {
-	xfree(ctrlp->path);
-	xfree(ctrlp);
-	store_open_disk_fd--;
-	return;
-    }
-    assert(mem != NULL);
-    assert(e->mem_status == NOT_IN_MEMORY);
-    assert(e->swap_status == SWAPOUT_WRITING || e->swap_status == SWAPOUT_DONE);
-    if (fd < 0) {
-	debug(20, 3) ("storeSwapInFileOpened: Failed\n"
-	    "\tFile:\t'%s'\n\t URL:\t'%s'\n",
-	    ctrlp->path, storeUrl(e));
-	storeEntryDump(e, 3);
-	store_open_disk_fd--;
-    } else if (e->swap_status != SWAPOUT_DONE) {
-	(void) 0;
-    } else if (fstat(fd, &sb) < 0) {
-	debug(20, 1) ("storeSwapInFileOpened: fstat() FD %d: %s\n", fd, xstrerror());
-	file_close(fd);
-	store_open_disk_fd--;
-	fd = -1;
-    } else if (sb.st_size == 0 || sb.st_size != e->swap_file_sz) {
-	debug(20, 1) ("storeSwapInFileOpened: %s: Size mismatch: %d(fstat) != %d(object)\n", ctrlp->path, (int) sb.st_size, e->swap_file_sz);
-	file_close(fd);
-	store_open_disk_fd--;
-	fd = -1;
-    }
-    if (fd < 0) {
-	storeReleaseRequest(e);
-    } else {
-	debug(20, 5) ("storeSwapInFileOpened: initialized '%s' for '%s'\n",
-	    ctrlp->path, storeUrl(e));
+    store_client *sc = data;
+    STCB *callback;
+    debug(20, 3) ("storeSwapInFileClosed: sio=%p, errflag=%d\n",
+	sio, errflag);
+    cbdataUnlock(sio);
+    sc->swapin_sio = NULL;
+    if ((callback = sc->callback)) {
+	assert(errflag <= 0);
+	sc->callback = NULL;
+	callback(sc->callback_data, sc->copy_buf, errflag);
     }
-    (ctrlp->callback) (fd, ctrlp->callback_data);
-    xfree(ctrlp->path);
-    xfree(ctrlp);
 }
Index: squid/src/store_swapmeta.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapmeta.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/src/store_swapmeta.c	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/src/store_swapmeta.c	26 Jan 2000 03:25:01 -0000	1.1.1.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapmeta.c,v 1.1.1.1 2000/01/26 03:21:47 hno Exp $
+ * $Id: store_swapmeta.c,v 1.1.1.2 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapfile Metadata
  * AUTHOR: Kostas Anagnostakis
@@ -126,7 +126,15 @@
     assert(buflen > (sizeof(char) + sizeof(int)));
     while (buflen - j > (sizeof(char) + sizeof(int))) {
 	type = buf[j++];
+	if (type < STORE_META_VOID || type > STORE_META_END) {
+	    debug(20, 0) ("storeSwapMetaUnpack: bad type (%d)!\n", type);
+	    break;
+	}
 	xmemcpy(&length, &buf[j], sizeof(int));
+	if (length < 0 || length > (1 << 10)) {
+	    debug(20, 0) ("storeSwapMetaUnpack: insane length (%d)!\n", length);
+	    break;
+	}
 	j += sizeof(int);
 	if (j + length > buflen) {
 	    debug(20, 0) ("storeSwapMetaUnpack: overflow!\n");
Index: squid/src/store_swapout.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapout.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/store_swapout.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/store_swapout.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapout.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: store_swapout.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapout Functions
  * AUTHOR: Duane Wessels
@@ -35,176 +35,116 @@
 
 #include "squid.h"
 
-typedef struct swapout_ctrl_t {
-    char *swapfilename;
-    int oldswapstatus;
-    StoreEntry *e;
-} swapout_ctrl_t;
-
-static FOCB storeSwapOutFileOpened;
 static off_t storeSwapOutObjectBytesOnDisk(const MemObject *);
 static void storeSwapOutStart(StoreEntry * e);
-static DWCB storeSwapOutHandle;
+static STIOCB storeSwapOutFileClosed;
 
 /* start swapping object to disk */
 static void
 storeSwapOutStart(StoreEntry * e)
 {
-    swapout_ctrl_t *ctrlp = xmalloc(sizeof(swapout_ctrl_t));
-    assert(e->mem_obj);
-    cbdataAdd(ctrlp, cbdataXfree, 0);
+    generic_cbdata *c;
+    MemObject *mem = e->mem_obj;
+    int swap_hdr_sz = 0;
+    tlv *tlv_list;
+    char *buf;
+    assert(mem);
     storeLockObject(e);
     e->swap_file_number = storeDirMapAllocate();
-    ctrlp->swapfilename = xstrdup(storeSwapFullPath(e->swap_file_number, NULL));
-    ctrlp->e = e;
-    ctrlp->oldswapstatus = e->swap_status;
-    e->swap_status = SWAPOUT_OPENING;
-    e->mem_obj->swapout.ctrl = ctrlp;
-    store_open_disk_fd++;
-    file_open(ctrlp->swapfilename,
-	O_WRONLY | O_CREAT | O_TRUNC,
-	storeSwapOutFileOpened,
-	ctrlp,
-	e);
-}
-
-static void
-storeSwapOutHandle(int fdnotused, int flag, size_t len, void *data)
-{
-    swapout_ctrl_t *ctrlp = data;
-    StoreEntry *e = ctrlp->e;
-    MemObject *mem = e->mem_obj;
-    debug(20, 3) ("storeSwapOutHandle: '%s', len=%d\n", storeKeyText(e->key), (int) len);
-    if (flag < 0) {
-	debug(20, 1) ("storeSwapOutHandle: SwapOut failure (err code = %d).\n",
-	    flag);
+    c = xcalloc(1, sizeof(*c));
+    c->data = e;
+    cbdataAdd(c, cbdataXfree, 0);
+    mem->swapout.sio = storeOpen(e->swap_file_number,
+	O_WRONLY, storeSwapOutFileClosed, c);
+    if (NULL == mem->swapout.sio) {
 	e->swap_status = SWAPOUT_NONE;
-	if (e->swap_file_number > -1) {
-	    storeUnlinkFileno(e->swap_file_number);
-	    storeDirMapBitReset(e->swap_file_number);
-	    if (flag == DISK_NO_SPACE_LEFT) {
-		storeDirDiskFull(e->swap_file_number);
-		storeDirConfigure();
-		storeConfigure();
-	    }
-	    e->swap_file_number = -1;
-	}
-	storeReleaseRequest(e);
-	storeSwapOutFileClose(e);
-	return;
-    }
-#if USE_ASYNC_IO
-    if (mem == NULL) {
-	debug(20, 1) ("storeSwapOutHandle: mem == NULL : Cancelling swapout\n");
-	return;
-    }
-#else
-    assert(mem != NULL);
-#endif
-    assert(mem->swap_hdr_sz != 0);
-    mem->swapout.done_offset += len;
-    if (e->store_status == STORE_PENDING) {
-	storeCheckSwapOut(e);
-	return;
-    } else if (mem->swapout.done_offset < objectLen(e) + mem->swap_hdr_sz) {
-	storeCheckSwapOut(e);
+	storeDirMapBitReset(e->swap_file_number);
+	e->swap_file_number = -1;
+	cbdataFree(c);
+	storeUnlockObject(e);
 	return;
     }
-    /* swapping complete */
-    debug(20, 5) ("storeSwapOutHandle: SwapOut complete: '%s' to %s.\n",
-	storeUrl(e), storeSwapFullPath(e->swap_file_number, NULL));
-    e->swap_file_sz = objectLen(e) + mem->swap_hdr_sz;
-    e->swap_status = SWAPOUT_DONE;
-    storeDirUpdateSwapSize(e->swap_file_number, e->swap_file_sz, 1);
-    if (storeCheckCachable(e)) {
-	storeLog(STORE_LOG_SWAPOUT, e);
-	storeDirSwapLog(e, SWAP_LOG_ADD);
-    }
-    /* Note, we don't otherwise call storeReleaseRequest() here because
-     * storeCheckCachable() does it for is if necessary */
-    storeSwapOutFileClose(e);
+    e->swap_status = SWAPOUT_WRITING;
+    cbdataLock(mem->swapout.sio);
+    debug(20, 5) ("storeSwapOutStart: Begin SwapOut '%s' to fileno %08X\n",
+	storeUrl(e), e->swap_file_number);
+    tlv_list = storeSwapMetaBuild(e);
+    buf = storeSwapMetaPack(tlv_list, &swap_hdr_sz);
+    storeSwapTLVFree(tlv_list);
+    mem->swap_hdr_sz = (size_t) swap_hdr_sz;
+    storeWrite(mem->swapout.sio, buf, mem->swap_hdr_sz, 0, xfree);
 }
 
 void
-storeCheckSwapOut(StoreEntry * e)
+storeSwapOut(StoreEntry * e)
 {
     MemObject *mem = e->mem_obj;
     off_t lowest_offset;
     off_t new_mem_lo;
-    off_t on_disk;
+    off_t on_disk = 0;
     size_t swapout_size;
     char *swap_buf;
     ssize_t swap_buf_len;
-    int hdr_len = 0;
     if (mem == NULL)
 	return;
     /* should we swap something out to disk? */
-    debug(20, 7) ("storeCheckSwapOut: %s\n", storeUrl(e));
-    debug(20, 7) ("storeCheckSwapOut: store_status = %s\n",
+    debug(20, 7) ("storeSwapOut: %s\n", storeUrl(e));
+    debug(20, 7) ("storeSwapOut: store_status = %s\n",
 	storeStatusStr[e->store_status]);
     if (EBIT_TEST(e->flags, ENTRY_ABORTED)) {
 	assert(EBIT_TEST(e->flags, RELEASE_REQUEST));
 	storeSwapOutFileClose(e);
 	return;
     }
-    debug(20, 7) ("storeCheckSwapOut: mem->inmem_lo = %d\n",
+    debug(20, 7) ("storeSwapOut: mem->inmem_lo = %d\n",
 	(int) mem->inmem_lo);
-    debug(20, 7) ("storeCheckSwapOut: mem->inmem_hi = %d\n",
+    debug(20, 7) ("storeSwapOut: mem->inmem_hi = %d\n",
 	(int) mem->inmem_hi);
-    debug(20, 7) ("storeCheckSwapOut: swapout.queue_offset = %d\n",
+    debug(20, 7) ("storeSwapOut: swapout.queue_offset = %d\n",
 	(int) mem->swapout.queue_offset);
-    debug(20, 7) ("storeCheckSwapOut: swapout.done_offset = %d\n",
-	(int) mem->swapout.done_offset);
-#if USE_ASYNC_IO
-    if (mem->inmem_hi < mem->swapout.queue_offset) {
-	storeAbort(e);
-	assert(EBIT_TEST(e->flags, RELEASE_REQUEST));
-	storeSwapOutFileClose(e);
-	return;
-    }
-#else
+    if (mem->swapout.sio)
+	debug(20, 7) ("storeSwapOut: storeOffset() = %d\n",
+	    (int) storeOffset(mem->swapout.sio));
     assert(mem->inmem_hi >= mem->swapout.queue_offset);
-#endif
     lowest_offset = storeLowestMemReaderOffset(e);
-    debug(20, 7) ("storeCheckSwapOut: lowest_offset = %d\n",
+    debug(20, 7) ("storeSwapOut: lowest_offset = %d\n",
 	(int) lowest_offset);
     new_mem_lo = lowest_offset;
     assert(new_mem_lo >= mem->inmem_lo);
-    /*
-     * We should only free up to what we know has been written to
-     * disk, not what has been queued for writing.  Otherwise there
-     * will be a chunk of the data which is not in memory and is
-     * not yet on disk.
-     */
-    if (storeSwapOutAble(e))
+    if (storeSwapOutAble(e)) {
+	/*
+	 * We should only free up to what we know has been written
+	 * to disk, not what has been queued for writing.  Otherwise
+	 * there will be a chunk of the data which is not in memory
+	 * and is not yet on disk.
+	 */
 	if ((on_disk = storeSwapOutObjectBytesOnDisk(mem)) < new_mem_lo)
 	    new_mem_lo = on_disk;
+    } else {
+	/*
+	 * Its not swap-able, so we must make it PRIVATE.  Even if
+	 * be only one MEM client and all others must read from
+	 * disk.
+	 */
+	storeReleaseRequest(e);
+    }
     stmemFreeDataUpto(&mem->data_hdr, new_mem_lo);
     mem->inmem_lo = new_mem_lo;
     if (e->swap_status == SWAPOUT_WRITING)
-	assert(mem->inmem_lo <= mem->swapout.done_offset);
+	assert(mem->inmem_lo <= on_disk);
     if (!storeSwapOutAble(e))
 	return;
     swapout_size = (size_t) (mem->inmem_hi - mem->swapout.queue_offset);
-    debug(20, 7) ("storeCheckSwapOut: swapout_size = %d\n",
+    debug(20, 7) ("storeSwapOut: swapout_size = %d\n",
 	(int) swapout_size);
     if (swapout_size == 0) {
-	if (e->store_status == STORE_OK && !storeSwapOutWriteQueued(mem)) {
-	    debug(20, 7) ("storeCheckSwapOut: nothing to write for STORE_OK\n");
-	    if (e->swap_file_number > -1) {
-		storeUnlinkFileno(e->swap_file_number);
-		storeDirMapBitReset(e->swap_file_number);
-		e->swap_file_number = -1;
-	    }
-	    e->swap_status = SWAPOUT_NONE;
-	    storeReleaseRequest(e);
+	if (e->store_status == STORE_OK)
 	    storeSwapOutFileClose(e);
-	}
-	return;
+	return;			/* Nevermore! */
     }
     if (e->store_status == STORE_PENDING) {
 	/* wait for a full block to write */
-	if (swapout_size < VM_WINDOW_SZ)
+	if (swapout_size < DISK_PAGE_SIZE)
 	    return;
 	/*
 	 * Wait until we are below the disk FD limit, only if the
@@ -213,149 +153,120 @@
 	if (storeTooManyDiskFilesOpen() && !fwdCheckDeferRead(-1, e))
 	    return;
     }
-    /* Ok, we have stuff to swap out.  Is there a swapout.fd open? */
+    /* Ok, we have stuff to swap out.  Is there a swapout.sio open? */
     if (e->swap_status == SWAPOUT_NONE) {
-	assert(mem->swapout.fd == -1);
+	assert(mem->swapout.sio == NULL);
 	assert(mem->inmem_lo == 0);
 	if (storeCheckCachable(e))
 	    storeSwapOutStart(e);
-	/* else ENTRY_CACHABLE will be cleared and we'll never get
-	 * here again */
-	return;
+	else
+	    return;
+	/* ENTRY_CACHABLE will be cleared and we'll never get here again */
     }
-    if (e->swap_status == SWAPOUT_OPENING)
+    if (NULL == mem->swapout.sio)
 	return;
-    assert(mem->swapout.fd > -1);
-    if (swapout_size > STORE_SWAP_BUF)
-	swapout_size = STORE_SWAP_BUF;
-    swap_buf = memAllocate(MEM_DISK_BUF);
-    swap_buf_len = stmemCopy(&mem->data_hdr,
-	mem->swapout.queue_offset,
-	swap_buf,
-	swapout_size);
-    if (swap_buf_len < 0) {
-	debug(20, 1) ("stmemCopy returned %d for '%s'\n", swap_buf_len, storeKeyText(e->key));
-	storeUnlinkFileno(e->swap_file_number);
-	storeDirMapBitReset(e->swap_file_number);
-	e->swap_file_number = -1;
-	e->swap_status = SWAPOUT_NONE;
-	memFree(swap_buf, MEM_DISK_BUF);
-	storeReleaseRequest(e);
-	storeSwapOutFileClose(e);
+    do {
+	if (swapout_size > DISK_PAGE_SIZE)
+	    swapout_size = DISK_PAGE_SIZE;
+	swap_buf = memAllocate(MEM_DISK_BUF);
+	swap_buf_len = stmemCopy(&mem->data_hdr,
+	    mem->swapout.queue_offset,
+	    swap_buf,
+	    swapout_size);
+	if (swap_buf_len < 0) {
+	    debug(20, 1) ("stmemCopy returned %d for '%s'\n", swap_buf_len, storeKeyText(e->key));
+	    storeUnlink(e->swap_file_number);
+	    storeDirMapBitReset(e->swap_file_number);
+	    e->swap_file_number = -1;
+	    e->swap_status = SWAPOUT_NONE;
+	    memFree(swap_buf, MEM_DISK_BUF);
+	    storeReleaseRequest(e);
+	    storeSwapOutFileClose(e);
+	    return;
+	}
+	debug(20, 3) ("storeSwapOut: swap_buf_len = %d\n", (int) swap_buf_len);
+	assert(swap_buf_len > 0);
+	debug(20, 3) ("storeSwapOut: swapping out %d bytes from %d\n",
+	    swap_buf_len, (int) mem->swapout.queue_offset);
+	mem->swapout.queue_offset += swap_buf_len;
+	storeWrite(mem->swapout.sio, swap_buf, swap_buf_len, -1, memFreeDISK);
+	/* the storeWrite() call might generate an error */
+	if (e->swap_status != SWAPOUT_WRITING)
+	    break;
+	swapout_size = (size_t) (mem->inmem_hi - mem->swapout.queue_offset);
+	if (e->store_status == STORE_PENDING)
+	    if (swapout_size < DISK_PAGE_SIZE)
+		break;
+    } while (swapout_size > 0);
+    if (NULL == mem->swapout.sio)
+	/* oops, we're not swapping out any more */
 	return;
+    if (e->store_status == STORE_OK) {
+	/*
+	 * If the state is STORE_OK, then all data must have been given
+	 * to the filesystem at this point because storeSwapOut() is
+	 * not going to be called again for this entry.
+	 */
+	assert(mem->inmem_hi == mem->swapout.queue_offset);
+	storeSwapOutFileClose(e);
     }
-    debug(20, 3) ("storeCheckSwapOut: swap_buf_len = %d\n", (int) swap_buf_len);
-    assert(swap_buf_len > 0);
-    debug(20, 3) ("storeCheckSwapOut: swapping out %d bytes from %d\n",
-	swap_buf_len, (int) mem->swapout.queue_offset);
-    mem->swapout.queue_offset += swap_buf_len - hdr_len;
-    file_write(mem->swapout.fd,
-	-1,
-	swap_buf,
-	swap_buf_len,
-	storeSwapOutHandle,
-	mem->swapout.ctrl,
-	memFreeDISK);
 }
 
 void
 storeSwapOutFileClose(StoreEntry * e)
 {
     MemObject *mem = e->mem_obj;
-    swapout_ctrl_t *ctrlp;
     assert(mem != NULL);
     debug(20, 3) ("storeSwapOutFileClose: %s\n", storeKeyText(e->key));
-    if (mem->swapout.fd < 0) {
-#if USE_ASYNC_IO
-	aioCancel(-1, e);	/* Make doubly certain pending ops are gone */
-#endif
+    debug(20, 3) ("storeSwapOutFileClose: sio = %p\n", mem->swapout.sio);
+    if (mem->swapout.sio == NULL)
 	return;
-    }
-    ctrlp = mem->swapout.ctrl;
-    file_close(mem->swapout.fd);
-    store_open_disk_fd--;
-    mem->swapout.fd = -1;
-    xfree(ctrlp->swapfilename);
-    cbdataFree(ctrlp);
-    mem->swapout.ctrl = NULL;
-    storeUnlockObject(e);
+    storeClose(mem->swapout.sio);
 }
 
 static void
-storeSwapOutFileOpened(void *data, int fd, int errcode)
+storeSwapOutFileClosed(void *data, int errflag, storeIOState * sio)
 {
-    swapout_ctrl_t *ctrlp = data;
-    StoreEntry *e = ctrlp->e;
+    generic_cbdata *c = data;
+    StoreEntry *e = c->data;
     MemObject *mem = e->mem_obj;
-    int swap_hdr_sz = 0;
-    tlv *tlv_list;
-    char *buf;
-    if (fd == -2 && errcode == -2) {	/* Cancelled - Clean up */
-	xfree(ctrlp->swapfilename);
-	cbdataFree(ctrlp);
-	mem->swapout.ctrl = NULL;
-	store_open_disk_fd--;
-	return;
-    }
-    assert(e->swap_status == SWAPOUT_OPENING);
-    if (fd < 0) {
-	debug(20, 0) ("storeSwapOutFileOpened: Unable to open swapfile: %s\n\t%s\n",
-	    ctrlp->swapfilename, xstrerror());
+    assert(e->swap_status == SWAPOUT_WRITING);
+    cbdataFree(c);
+    if (errflag) {
+	debug(20, 1) ("storeSwapOutFileClosed: swapfile %08X, errflag=%d\n\t%s\n",
+	    e->swap_file_number, errflag, xstrerror());
 	/*
 	 * yuck.  don't clear the filemap bit for some errors so that
 	 * we don't try re-using it over and over
 	 */
 	if (errno != EPERM)
 	    storeDirMapBitReset(e->swap_file_number);
+	if (errflag == DISK_NO_SPACE_LEFT) {
+	    storeDirDiskFull(e->swap_file_number);
+	    storeDirConfigure();
+	    storeConfigure();
+	}
+	storeReleaseRequest(e);
 	e->swap_file_number = -1;
-	e->swap_status = ctrlp->oldswapstatus;
-	xfree(ctrlp->swapfilename);
-	cbdataFree(ctrlp);
-	mem->swapout.ctrl = NULL;
-	store_open_disk_fd--;
-	return;
+	e->swap_status = SWAPOUT_NONE;
+    } else {
+	/* swapping complete */
+	debug(20, 3) ("storeSwapOutFileClosed: SwapOut complete: '%s' to %08X\n",
+	    storeUrl(e), e->swap_file_number);
+	e->swap_file_sz = objectLen(e) + mem->swap_hdr_sz;
+	e->swap_status = SWAPOUT_DONE;
+	storeDirUpdateSwapSize(e->swap_file_number, e->swap_file_sz, 1);
+	if (storeCheckCachable(e)) {
+	    storeLog(STORE_LOG_SWAPOUT, e);
+	    storeDirSwapLog(e, SWAP_LOG_ADD);
+	}
     }
-    mem->swapout.fd = (short) fd;
-    e->swap_status = SWAPOUT_WRITING;
-    debug(20, 5) ("storeSwapOutFileOpened: Begin SwapOut '%s' to FD %d '%s'\n",
-	storeUrl(e), fd, ctrlp->swapfilename);
-    debug(20, 5) ("swap_file_number=%08X\n", e->swap_file_number);
-    tlv_list = storeSwapMetaBuild(e);
-    buf = storeSwapMetaPack(tlv_list, &swap_hdr_sz);
-    storeSwapTLVFree(tlv_list);
-    mem->swap_hdr_sz = (size_t) swap_hdr_sz;
-    file_write(mem->swapout.fd,
-	-1,
-	buf,
-	mem->swap_hdr_sz,
-	storeSwapOutHandle,
-	ctrlp,
-	xfree);
-}
-
-/*
- * Return 1 if we have some data queued.  If there is no data queued,
- * then 'done_offset' equals 'queued_offset' + 'swap_hdr_sz'
- *
- * done_offset represents data written to disk (including the swap meta
- * header), but queued_offset is relative to the in-memory data, and
- * does not include the meta header.
- */
-int
-storeSwapOutWriteQueued(MemObject * mem)
-{
-    /*
-     * this function doesn't get called much, so I'm using
-     * local variables to improve readability.  pphhbbht.
-     */
-    off_t queued = mem->swapout.queue_offset;
-    off_t done = mem->swapout.done_offset;
-    size_t hdr = mem->swap_hdr_sz;
-    assert(queued + hdr >= done);
-    return (queued + hdr > done);
+    debug(20, 3) ("storeSwapOutFileClosed: %s:%d\n", __FILE__, __LINE__);
+    mem->swapout.sio = NULL;
+    cbdataUnlock(sio);
+    storeUnlockObject(e);
 }
 
-
 /*
  * How much of the object data is on the disk?
  */
@@ -363,7 +274,7 @@
 storeSwapOutObjectBytesOnDisk(const MemObject * mem)
 {
     /*
-     * NOTE: done_offset represents the disk file size,
+     * NOTE: storeOffset() represents the disk file size,
      * not the amount of object data on disk.
      * 
      * If we don't have at least 'swap_hdr_sz' bytes
@@ -373,9 +284,13 @@
      * meaning we haven't even opened the swapout file
      * yet.
      */
-    if (mem->swapout.done_offset <= mem->swap_hdr_sz)
+    off_t nwritten;
+    if (mem->swapout.sio == NULL)
 	return 0;
-    return mem->swapout.done_offset - mem->swap_hdr_sz;
+    nwritten = storeOffset(mem->swapout.sio);
+    if (nwritten <= mem->swap_hdr_sz)
+	return 0;
+    return nwritten - mem->swap_hdr_sz;
 }
 
 /*
@@ -385,13 +300,10 @@
 storeSwapOutAble(const StoreEntry * e)
 {
     store_client *sc;
-    if (e->swap_status == SWAPOUT_OPENING)
-	return 1;
-    if (e->mem_obj->swapout.fd > -1)
+    if (e->mem_obj->swapout.sio != NULL)
 	return 1;
     if (e->mem_obj->inmem_lo > 0)
 	return 0;
-    /* swapout.fd == -1 && inmem_lo == 0 */
     /*
      * If there are DISK clients, we must write to disk
      * even if its not cachable
@@ -399,5 +311,8 @@
     for (sc = e->mem_obj->clients; sc; sc = sc->next)
 	if (sc->type == STORE_DISK_CLIENT)
 	    return 1;
+    if (store_dirs_rebuilding)
+	if (!EBIT_TEST(e->flags, ENTRY_SPECIAL))
+	    return 0;
     return EBIT_TEST(e->flags, ENTRY_CACHABLE);
 }
